// -------------------------------------------------------------------------------------
// ExecMonitor.h
// (Indent:4, Tabs:4)
// -------------------------------------------------------------------------------------
// Copyright 1996 Persistent Technologies, Inc. - all rights reserved
// -------------------------------------------------------------------------------------
// This source code comes with no warranty of any kind, and the user assumes all 
// responsibility for its use.
// -------------------------------------------------------------------------------------
#import <objc/Object.h>
#import <appkit/graphics.h>

// -------------------------------------------------------------------------------------
@interface ExecMonitor : Object
{

	/* monitor */
	id			exeWindow;
	id			btnConnect;
	id			autoConnect;
	id			btnGetMail;
	id			appMatrix;
	id			cmdMessage;
	id			pingMessage;
	id			cmdShellScroll;
	id			pppLogScroll;
	
	/* exec ids */
	id			pingExeId;
	id			connectExeId;
	id			pppLogExeId;
	
	/* connect timer */
	long		_connectTime;
	long		_connectStart;
	int			_showTileTime;

	/* timers */
	void		*clockTimer;
	void		*ppingTimer;
	void		*checkTimer;
	void		*pppdTimer;

	/* run flags */
	BOOL		_alreadyConnected;
	BOOL		_isConnected;
	BOOL		_isDisconnecting;
	BOOL		_shutDown;
	id			textFont;
	
}

// -------------------------------------------------------------------------------------

+ (void)updateFromDefaults;
- (void)updateFromDefaults;

+ (id)sharedPPPMonitor;
+ (BOOL)shutDown;
+ (BOOL)canShutDown;
- (BOOL)isShuttingDown;
- (BOOL)canShutDown;

- (BOOL)isPPPDRunning;
- (BOOL)isReallyConnected;
- (BOOL)isPPPDriverLoaded;
- (void)enableConnectButton:(id)doDelay;

- (void)tailLogFile:(id)sender;
- (void)clearLog:(id)sender;

- (void)commandDidComplete:execId withError:(int)err;

+ terminalCommand:(const char*)cmd title:(const char*)title;

@end
